// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package v1

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// VaultClient is the client API for Vault service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type VaultClient interface {
	RunVaultExport(ctx context.Context, in *RunVaultExportRequest, opts ...grpc.CallOption) (*RunVaultExportResponse, error)
	RunVaultRestore(ctx context.Context, in *RunVaultRestoreRequest, opts ...grpc.CallOption) (*RunVaultRestoreResponse, error)
	GetVaultExport(ctx context.Context, in *GetVaultExportRequest, opts ...grpc.CallOption) (*GetVaultExportResponse, error)
	GetVaultExports(ctx context.Context, in *GetVaultExportsRequest, opts ...grpc.CallOption) (*GetVaultExportsResponse, error)
	GetVaultRestore(ctx context.Context, in *GetVaultRestoreRequest, opts ...grpc.CallOption) (*GetVaultRestoreResponse, error)
	GetVaultRestores(ctx context.Context, in *GetVaultRestoresRequest, opts ...grpc.CallOption) (*GetVaultRestoresResponse, error)
}

type vaultClient struct {
	cc grpc.ClientConnInterface
}

func NewVaultClient(cc grpc.ClientConnInterface) VaultClient {
	return &vaultClient{cc}
}

func (c *vaultClient) RunVaultExport(ctx context.Context, in *RunVaultExportRequest, opts ...grpc.CallOption) (*RunVaultExportResponse, error) {
	out := new(RunVaultExportResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.Vault/RunVaultExport", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultClient) RunVaultRestore(ctx context.Context, in *RunVaultRestoreRequest, opts ...grpc.CallOption) (*RunVaultRestoreResponse, error) {
	out := new(RunVaultRestoreResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.Vault/RunVaultRestore", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultClient) GetVaultExport(ctx context.Context, in *GetVaultExportRequest, opts ...grpc.CallOption) (*GetVaultExportResponse, error) {
	out := new(GetVaultExportResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.Vault/GetVaultExport", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultClient) GetVaultExports(ctx context.Context, in *GetVaultExportsRequest, opts ...grpc.CallOption) (*GetVaultExportsResponse, error) {
	out := new(GetVaultExportsResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.Vault/GetVaultExports", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultClient) GetVaultRestore(ctx context.Context, in *GetVaultRestoreRequest, opts ...grpc.CallOption) (*GetVaultRestoreResponse, error) {
	out := new(GetVaultRestoreResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.Vault/GetVaultRestore", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultClient) GetVaultRestores(ctx context.Context, in *GetVaultRestoresRequest, opts ...grpc.CallOption) (*GetVaultRestoresResponse, error) {
	out := new(GetVaultRestoresResponse)
	err := c.cc.Invoke(ctx, "/api.infranetes.user.v1.Vault/GetVaultRestores", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// VaultServer is the server API for Vault service.
// All implementations should embed UnimplementedVaultServer
// for forward compatibility
type VaultServer interface {
	RunVaultExport(context.Context, *RunVaultExportRequest) (*RunVaultExportResponse, error)
	RunVaultRestore(context.Context, *RunVaultRestoreRequest) (*RunVaultRestoreResponse, error)
	GetVaultExport(context.Context, *GetVaultExportRequest) (*GetVaultExportResponse, error)
	GetVaultExports(context.Context, *GetVaultExportsRequest) (*GetVaultExportsResponse, error)
	GetVaultRestore(context.Context, *GetVaultRestoreRequest) (*GetVaultRestoreResponse, error)
	GetVaultRestores(context.Context, *GetVaultRestoresRequest) (*GetVaultRestoresResponse, error)
}

// UnimplementedVaultServer should be embedded to have forward compatible implementations.
type UnimplementedVaultServer struct {
}

func (UnimplementedVaultServer) RunVaultExport(context.Context, *RunVaultExportRequest) (*RunVaultExportResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RunVaultExport not implemented")
}
func (UnimplementedVaultServer) RunVaultRestore(context.Context, *RunVaultRestoreRequest) (*RunVaultRestoreResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RunVaultRestore not implemented")
}
func (UnimplementedVaultServer) GetVaultExport(context.Context, *GetVaultExportRequest) (*GetVaultExportResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVaultExport not implemented")
}
func (UnimplementedVaultServer) GetVaultExports(context.Context, *GetVaultExportsRequest) (*GetVaultExportsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVaultExports not implemented")
}
func (UnimplementedVaultServer) GetVaultRestore(context.Context, *GetVaultRestoreRequest) (*GetVaultRestoreResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVaultRestore not implemented")
}
func (UnimplementedVaultServer) GetVaultRestores(context.Context, *GetVaultRestoresRequest) (*GetVaultRestoresResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVaultRestores not implemented")
}

// UnsafeVaultServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to VaultServer will
// result in compilation errors.
type UnsafeVaultServer interface {
	mustEmbedUnimplementedVaultServer()
}

func RegisterVaultServer(s grpc.ServiceRegistrar, srv VaultServer) {
	s.RegisterService(&Vault_ServiceDesc, srv)
}

func _Vault_RunVaultExport_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RunVaultExportRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServer).RunVaultExport(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.Vault/RunVaultExport",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServer).RunVaultExport(ctx, req.(*RunVaultExportRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vault_RunVaultRestore_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RunVaultRestoreRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServer).RunVaultRestore(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.Vault/RunVaultRestore",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServer).RunVaultRestore(ctx, req.(*RunVaultRestoreRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vault_GetVaultExport_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVaultExportRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServer).GetVaultExport(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.Vault/GetVaultExport",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServer).GetVaultExport(ctx, req.(*GetVaultExportRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vault_GetVaultExports_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVaultExportsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServer).GetVaultExports(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.Vault/GetVaultExports",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServer).GetVaultExports(ctx, req.(*GetVaultExportsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vault_GetVaultRestore_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVaultRestoreRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServer).GetVaultRestore(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.Vault/GetVaultRestore",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServer).GetVaultRestore(ctx, req.(*GetVaultRestoreRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vault_GetVaultRestores_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVaultRestoresRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServer).GetVaultRestores(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/api.infranetes.user.v1.Vault/GetVaultRestores",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServer).GetVaultRestores(ctx, req.(*GetVaultRestoresRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Vault_ServiceDesc is the grpc.ServiceDesc for Vault service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Vault_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "api.infranetes.user.v1.Vault",
	HandlerType: (*VaultServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "RunVaultExport",
			Handler:    _Vault_RunVaultExport_Handler,
		},
		{
			MethodName: "RunVaultRestore",
			Handler:    _Vault_RunVaultRestore_Handler,
		},
		{
			MethodName: "GetVaultExport",
			Handler:    _Vault_GetVaultExport_Handler,
		},
		{
			MethodName: "GetVaultExports",
			Handler:    _Vault_GetVaultExports_Handler,
		},
		{
			MethodName: "GetVaultRestore",
			Handler:    _Vault_GetVaultRestore_Handler,
		},
		{
			MethodName: "GetVaultRestores",
			Handler:    _Vault_GetVaultRestores_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "infranetes/user/v1/vault.proto",
}
